<template>
    <div class="card border-left-primary shadow h-100 py-2 mb-3">
        <div class="card-body">
            <div class="row no-gutters align-items-center text-truncate">
                <div class="hello" id = "chartdiv"  ref="chartdiv">
  </div>
            </div>
        </div>
    </div>
</template>
  
<script lang=ts>
    import { DateTime } from "luxon";
    import { onMounted } from 'vue';
    import * as am5 from '@amcharts/amcharts5';
    import * as am5xy from '@amcharts/amcharts5/xy';
    import am5themes_Animated from '@amcharts/amcharts5/themes/Animated';
    
    interface OperationsType{
        startV: string,
        endV: string,
        category: string,
        deb: string,
        fin: string,
        type: string,
        color: string,
    }
    export default {
        props: {
        items: Array,
    },
    setup(props) {
        
        onMounted(() => {
            const opes = props.items as Array<OperationsType>
                const maxDate = opes.reduce((max, obj) => {
                    return Math.max(max, new Date(obj.endV));
                }, new Date(-8640000000000000));
            const timestamp = 1609459200000; // 15 septembre 2021
            const dateMax = new Date(maxDate);
            dateMax.setMonth(dateMax.getMonth() + 2); // Ajoute 3 mois à la date
            let count = opes.length;
            let size = 15;
            size = count < 15 ? 20 : size;
            size = count < 10 ? 25 : size;
            size = count > 100 ? 13 : size;
            let height = size * count;
            height = height < 100 ? 100 : height;
            //formatterData(props.items);
            let root = am5.Root.new('chartdiv');

            root.setThemes([am5themes_Animated.new(root)]);

            let chart = root.container.children.push(
            am5xy.XYChart.new(root, {
                panY: false,
                layout: root.horizontalLayout,
                height:height
            }));
            root.dateFormatter.set("dateFormat", "yyyy-MM-dd");
            const myTheme = am5.Theme.new(root);      

            chart.bottomAxesContainer.set("layout", root.horizontalLayout);
            // Define data
            let data:Array<Object> = []

            opes.map((value, key) => {

                let date1 = value?.startV;
                let date2 = value?.endV;
                const color = value?.color
                data.push({
                    ...value,
                    startV : (DateTime.fromISO(date1).endOf('day').toUnixInteger()) * 1000,
                    endV : (DateTime.fromISO(date2).endOf('day').toUnixInteger())* 1000,
                    columnSettings: {
                        fill: am5.color(color),
                        stroke: am5.color(color),
                        ellipsis: "..."
                    }
         
                });
            }); 
            
            var yRenderer = am5xy.AxisRendererY.new(root, {
                inversed:true,
                cellStartLocation:0.2,
                cellEndLocation:0.8,
                height:1,
                minGridDistance:30
            });

            yRenderer.labels.template.setAll({
                disabled:true               
            });

            yRenderer.grid.template.set("opacity", 0);
            
            // Create Y-axis
            let categoryAxis = chart.yAxes.push(
                am5xy.CategoryAxis.new(root, {
                    categoryField: "category",
                    tooltip: am5.Tooltip.new(root, {}),
                    renderer: yRenderer,                  
                    
                })
            );
            categoryAxis.get("renderer").labels.template.setAll({
                opacity: 0,
                disabled: true,
            });
            
            categoryAxis.get("renderer").labels.template.setAll({
                oversizedBehavior: "truncate",
                maxWidth: 1,
                ellipsis: "..."
            });
             categoryAxis.data.setAll(data)

            // Create X-Axis
            let dateAxis =  chart.xAxes.push(
                am5xy.DateAxis.new(root, {
                    baseInterval: { timeUnit: "day", count: 1 },
                    max : dateMax.getTime(),
                    renderer: am5xy.AxisRendererX.new(root, {
                        minGridDistance: 30,
                        height:15,
                        opacity:1,
                        fill: am5.Color.fromString("#EDEDED") ,
                    }),
                    
                })
            );
            dateAxis.get("renderer").labels.template.setAll({
                height:20,
                fontSize: 12,
                fill:  am5.Color.fromString("#C9C9C9") ,

            });
            dateAxis.get("renderer").labels.template.setup = function(target) {
                target.set("background", am5.Rectangle.new(root, {
                    fill: am5.color("#EDEDED"),
                    height:15,
                }))
            }

         if(dateAxis){
             dateAxis.get("dateFormats")["month"] = "MM";
             dateAxis.get("dateFormats")["month"] = "MM";

         }
            
            let series = chart.series.push(
                am5xy.ColumnSeries.new(root, {
                    xAxis: dateAxis,
                    yAxis: categoryAxis,
                    valueXField: 'endV',
                    openValueXField:'startV',
                    categoryYField: "category",
                    tooltip: am5.Tooltip.new(root, {
                        pointerOrientation: "horizontal",
                        labelText: '{type} \n du {deb} au {fin}',
                        centerX:am5.percent(50),
                        centerY: am5.percent(50),
                    })
                })
            );
            series.columns.template.setAll({
                cornerRadiusTL: 5,
                cornerRadiusTR: 5,
                cornerRadiusBL: 5,
                cornerRadiusBR: 5,
                height:15,
                opacity : 1,
                tooltipText :'{type} \n du {deb} au {fin}',
                centerX:am5.percent(50),
                centerY: am5.percent(50),
                templateField: "columnSettings",
                
                
            });
            series.data.setAll(data);
            
            series.bullets.push(function(root, series, dataItem) {
                return am5.Bullet.new(root, {
                    autoRotate: true,
                    sprite: am5.Label.new(root, {
                    text: "{type}",
                    fill: am5.color("#FFF"),
                    centerX: am5.percent(50),
                    textAlign: "center",
                    centerY: am5.percent(50),
                    fontSize:10,
                    populateText: true,
                    ellipsis: '...',
                    oversizedBehavior: "truncate",
                    })
                });
            });
            // Add legend


 
        });
        return {

        };
    },
    };
</script>
  
  <!-- Add "scoped" attribute to limit CSS to this component only -->
  <style scoped>
  .hello {
    width: 100%;
    min-height: 175px;
  }
  
  </style>